<template>
    <div class="shadow bg-white pt-2 pb-2 px-2 rounded">
        <div v-if="item.issue" class="flex items-start">
            <p>{{ item.issue.title }}</p>
            <p class="bg-yellow-300 rounded p-1 text-xs ml-auto">issue</p>
        </div>
        <div v-if="item.costunit" class="flex items-start cursor-pointer	">
            <p>{{ item.costunit.name }}</p>
            <p class="rounded p-1 text-xs ml-auto" :style="{'background-color': item.customer.color || '#000', 'color': luminosity(item.customer.color || '#000') < 60 ? '#fff' : '#000'}">
                {{ item.customer.name }}
            </p>
        </div>

        

        <div class="mb-2">
            <div class="inline-block relative">
                <div class="flex">
                    <p class="text-sm"><fa icon="clock" class="rounded-full mr-2" :class="{'pulse pulse--small': item.is_active}" /></p>
                    <p class="text-sm font-bold cursor-pointer" v-if="!item.is_active" @click="toggleDurationEdit()">
                        {{ $time.formatDuration(item.duration, true) }}
                    </p>
                    <p class="text-sm font-bold" v-if="item.is_active">
                        {{ durationFormatted(item.updated_at - item.duration, true) }}
                    </p>
                </div>

                <div v-if="editDuration" class="absolute bg-gray-400 flex items-center p-2 shadow-md rounded" style="top: 50%; left: 0; transform: translate(0, -50%)">
                    <input type="text" style="width: 60px;" class="bg-gray-200 text-gray-700 border border-gray-200 rounded text-sm px-2 py-1" v-model="editableDuration" />
                    <span class="ml-1 mr-2">Minutes</span>
                    <custom-button positive css-class="text-xs" icon="check" @click="saveDuration()" style="padding: 5px 10px;"></custom-button>
                    <custom-button negative css-class="text-xs ml-1" icon="times" @click="editDuration = false" style="padding: 5px 10px;"></custom-button>
                </div>
            </div>
        </div>

        <div class="mb-3">
            <div v-if="edit">
                <tw-textarea v-model="itemMessage" label="Beschreibung" :required="isMessageRequired" />
                <tw-textarea v-model="itemComment" label="Kommentar" class="mt-2" />
            </div>
            <div v-else>
                <div class="cursor-text" @click="edit = true">
                    <p class="text-xs" v-if="itemMessage">{{ itemMessage }}</p>
                    <p class="text-xs text-gray-600" v-if="itemComment">{{ itemComment }}</p>
                </div>
            </div>
        </div>

        <div class="mt-2 flex items-end">
            <div class="mr-2">
                <div v-if="!item.is_active">
                    <custom-button positive css-class="text-xs" icon="redo" @click="restartItem"></custom-button>
                </div>
                <div v-else>
                    <custom-button negative css-class="text-xs" icon="stop" @click="stopItem"></custom-button>
                </div>
            </div>
            <div class="ml-auto flex">
                <div
                    v-if="hasStatsButton"
                >
                    <custom-button css-class="text-xs" icon="chart-pie" @click="toggleStatus()"></custom-button>
                </div>
                <div>
                    <custom-button css-class="text-xs" :icon="edit ? 'check' : 'pen'" @click="edit = !edit"></custom-button>
                </div>
                <div class="ml-2" v-if="!item.is_active">
                    <custom-button css-class="text-xs" icon="trash" negative @click="deleteItem"></custom-button>
                </div>
            </div>
        </div>

        <project-detail
            v-if="statsCostUnitId"
            :costunit="statsCostUnitId"
        />
    </div>
</template>

<script>
import CustomButton from '~/components/CustomButton'
import { mapState, mapGetters } from 'vuex'
import TwTextarea from '~/components/TwTextarea'
import debounce from 'lodash.debounce'
import ProjectDetail from './ProjectDetail.vue'

export default {
    name: 'time-item',
    components: {
        TwTextarea,
        CustomButton,
        ProjectDetail
    },
    props : {
        'item' : { type: Object },
        'restart': { type: Function },
        'stop': {type: Function},
        'timeline': {type: Function},
        'async' : {type: Function},
    },
    data: function() {
        return {
            statsCostUnitId: false,
            message: this.item.message,
            comment: this.item.comment,
            edit: false,
            editDuration: false,
            editableDuration: 0,
        }
    },
    computed: {
        hasStatsButton : function() {
            if (this.item.costunit || (this.item.issue && this.item.issue.gitlabProject && this.item.issue.gitlabProject.costunit)) {
                return true;
            }
            return false
        },
        ...mapState({
            now: state => state.time.now
        }),
        ...mapGetters('time', [
            'durationFormatted'
        ]),
        ...{
            itemMessage : {
                get : function() {
                    return this.message;
                },
                set : function(value) {
                    this.message = value;
                }
            },
            itemComment : {
                get : function() {
                    return this.comment;
                },
                set : function(value) {
                    this.comment = value;
                }
            },
            isMessageRequired() {

                if (this.item.issue) {
                    return false;
                }
                if ((this.item.costunit && this.item.costunit.is_message_required)) {
                    return true
                }

                return false
            },
            isMessageValid() {
                return typeof this.message === 'string' && !!this.message.trim()
            }
        }
    },
    methods: {
        toggleStatus() {
            if (this.statsCostUnitId) {
                this.statsCostUnitId = false
            } else {
                if (this.item.costunit) {
                    this.statsCostUnitId = this.item.costunit.id
                } else if (this.item.issue.gitlabProject.costunit) {
                    this.statsCostUnitId = this.item.issue.gitlabProject.costunit.id
                }
            }
        },
        toggleDurationEdit() {
            if (this.editDuration == false) {
                this.editDuration = true;
                this.editableDuration = Math.round(this.item.duration / 60);
            } else {
                this.editDuration = false;
            }
        },
        saveDuration() {
            this.$axios.put('/time/' + this.item.id, {'duration': this.editableDuration * 60}).then(response => {
                this.toggleDurationEdit();
                this.timeline();
                this.async();
            });
        },
        restartItem() {
            this.restart(this.item);
        },
        stopItem() {
            this.stop(this.item).then(response => {
                this.$store.commit('timeline/reset');
                this.timeline();
            });
        },
        saveMessage(newVal) {
            this.$axios.put('/time/' + this.item.id, {'message': newVal}).then(() => {
                this.async();
            });
        },
        saveComment(newVal) {
            this.$axios.put('/time/' + this.item.id, {'comment': newVal}).then(() => {
                this.async();
            });
        },
        deleteItem() {
            if (confirm("Are you sure to delete this item?") == true) {
                this.$axios.delete('/time/' + this.item.id).then(response => {
                    this.timeline();
                    this.async();
                });
            }
        },
        luminosity(H) {
            if (!H) {
                return 100
            }

            // Convert hex to RGB first
            let r = 0, g = 0, b = 0;
            if (H.length == 4) {
                r = "0x" + H[1] + H[1];
                g = "0x" + H[2] + H[2];
                b = "0x" + H[3] + H[3];
            } else if (H.length == 7) {
                r = "0x" + H[1] + H[2];
                g = "0x" + H[3] + H[4];
                b = "0x" + H[5] + H[6];
            }

            // Then to HSL
            r /= 255;
            g /= 255;
            b /= 255;

            let cmin = Math.min(r,g,b),
                cmax = Math.max(r,g,b),
                l = 0;

            l = (cmax + cmin) / 2;
            l = +(l * 100).toFixed(1);

            return l;
        }
    },
    created() {
        this.edit = !this.isMessageValid && this.isMessageRequired
    },
    watch: {
        itemMessage: debounce(function(newVal) {
            this.saveMessage(newVal)
        }, 500),
        itemComment: debounce(function(newVal) {
            this.saveComment(newVal);
        }, 500),
        item(newVal) {
            this.message = newVal.message
            this.comment = newVal.comment
        }
    }
}
</script>
